// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/ReadDocument.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.marker;


@SuppressWarnings("fallthrough")
public class ReadDocument extends JFlexAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int inMain = 2;
  public static final int inAnnex = 4;
  public static final int inAnnexEU = 6;
  public static final int inAnnexHeaderWithP = 8;
  public static final int inAnnexHeader = 10;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5, 5
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\5\0\1\3\10\0\1\4\12\0\1\5\1\6\1\7"+
    "\1\0\1\10\2\0\1\11\1\12\1\13\1\14\1\15"+
    "\1\0\1\16\1\17\1\20\1\0\1\21\1\22\1\23"+
    "\1\24\1\25\1\26\1\0\1\27\1\30\1\31\1\32"+
    "\4\0\1\33\6\0\1\11\1\12\1\13\1\14\1\15"+
    "\1\0\1\16\1\17\1\20\1\0\1\21\1\22\1\23"+
    "\1\24\1\25\1\26\1\0\1\27\1\30\1\31\1\32"+
    "\4\0\1\33\265\0\2\20\115\0\1\30\u0182\0\1\1"+
    "\u0127\0\1\21\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\6\0\2\1\3\2\3\1\35\0\1\3\55\0\1\4"+
    "\12\0\1\5\1\0\1\6\1\7\5\0\1\10\20\0"+
    "\1\11\42\0\1\12\4\0\1\13";

  private static int [] zzUnpackAction() {
    int [] result = new int[167];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\34\0\70\0\124\0\160\0\214\0\250\0\304"+
    "\0\250\0\340\0\374\0\u0118\0\u0134\0\u0150\0\u016c\0\u0188"+
    "\0\u01a4\0\u01c0\0\u01dc\0\u01f8\0\u0214\0\u0230\0\u024c\0\u0268"+
    "\0\u0284\0\u02a0\0\u02bc\0\u02d8\0\u02f4\0\u0310\0\u032c\0\u0348"+
    "\0\u0364\0\u0380\0\u039c\0\u03b8\0\u03d4\0\u03f0\0\u040c\0\u0428"+
    "\0\u0444\0\u0460\0\u047c\0\250\0\u0498\0\u04b4\0\u04d0\0\u04ec"+
    "\0\u0508\0\u0524\0\u0540\0\u055c\0\u0578\0\u0594\0\u05b0\0\u05cc"+
    "\0\u05e8\0\u0604\0\u0620\0\u063c\0\u0658\0\u0674\0\u0690\0\u06ac"+
    "\0\u06c8\0\u06e4\0\u0700\0\u071c\0\u0738\0\u0754\0\u0770\0\u078c"+
    "\0\u07a8\0\u07c4\0\u07e0\0\u07fc\0\u0818\0\u0834\0\u0850\0\u086c"+
    "\0\u0888\0\u08a4\0\u08c0\0\u08dc\0\u08f8\0\u0914\0\u0930\0\u094c"+
    "\0\u0968\0\u0984\0\u09a0\0\u09bc\0\u09d8\0\u09f4\0\u0a10\0\u0a2c"+
    "\0\u0a48\0\u0984\0\u0a64\0\u0a80\0\250\0\u0a9c\0\250\0\250"+
    "\0\u0ab8\0\u0ad4\0\u0af0\0\u0b0c\0\u0b28\0\250\0\u0b44\0\u0b60"+
    "\0\u0b7c\0\u0b98\0\u0bb4\0\u0bd0\0\u0bec\0\u0c08\0\u0c24\0\u0c40"+
    "\0\u0c5c\0\u0c78\0\u0c94\0\u0cb0\0\u0ccc\0\u0ce8\0\250\0\u0d04"+
    "\0\u0d20\0\u0d3c\0\u0d58\0\u0d74\0\u0d90\0\u0dac\0\u0dc8\0\u0de4"+
    "\0\u0e00\0\u0e1c\0\u0e38\0\u0e54\0\u0e70\0\u0e8c\0\u0ea8\0\u0ec4"+
    "\0\u0ee0\0\u0efc\0\u0f18\0\u0f34\0\u0f50\0\u0f6c\0\u0f88\0\u0fa4"+
    "\0\u0fc0\0\u0fdc\0\u0ff8\0\u1014\0\u1030\0\u104c\0\u1068\0\u1084"+
    "\0\u10a0\0\250\0\u10bc\0\u10d8\0\u10f4\0\u1110\0\250";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[167];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\7\7\1\10\24\7\7\11\1\12\33\11\1\13\24\11"+
    "\7\7\1\14\33\7\1\15\33\7\1\16\24\7\57\0"+
    "\1\17\14\0\1\20\33\0\1\21\33\0\1\22\33\0"+
    "\1\23\33\0\1\24\56\0\1\25\27\0\1\26\33\0"+
    "\1\27\33\0\1\30\27\0\1\31\37\0\1\32\31\0"+
    "\1\33\41\0\1\34\33\0\1\35\33\0\1\36\11\0"+
    "\1\37\55\0\1\40\11\0\1\41\47\0\1\42\33\0"+
    "\1\43\33\0\1\44\40\0\1\45\26\0\1\46\23\0"+
    "\1\47\2\0\1\50\24\0\1\51\33\0\1\52\33\0"+
    "\1\53\36\0\1\54\30\0\1\55\50\0\1\56\36\0"+
    "\1\57\22\0\1\60\30\0\1\61\33\0\1\62\42\0"+
    "\1\63\35\0\1\64\24\0\1\65\45\0\1\66\30\0"+
    "\1\67\33\0\1\70\35\0\1\71\24\0\1\72\50\0"+
    "\1\73\14\0\1\74\42\0\1\75\33\0\1\76\42\0"+
    "\1\77\20\0\1\100\40\0\1\101\42\0\1\102\16\0"+
    "\1\103\33\0\1\104\33\0\1\105\27\0\1\106\37\0"+
    "\1\107\41\0\1\110\26\0\1\111\33\0\1\112\45\0"+
    "\1\113\34\0\1\114\26\0\1\115\24\0\1\116\27\0"+
    "\1\117\33\0\1\120\53\0\1\121\27\0\1\122\37\0"+
    "\1\123\26\0\1\124\40\0\1\125\33\0\1\126\13\0"+
    "\1\127\23\0\1\130\1\0\1\131\4\0\1\132\50\0"+
    "\1\133\37\0\1\134\27\0\1\135\33\0\1\136\41\0"+
    "\1\137\10\140\1\0\23\140\24\0\1\141\10\0\2\142"+
    "\1\143\3\0\1\144\34\0\1\145\50\0\1\146\16\0"+
    "\1\147\33\0\1\150\43\0\1\151\13\0\10\140\1\132"+
    "\23\140\12\0\1\152\45\0\1\153\26\0\1\154\3\0"+
    "\1\155\20\0\1\156\50\0\1\157\36\0\1\160\15\0"+
    "\1\161\26\0\1\162\55\0\1\163\30\0\1\164\35\0"+
    "\1\165\35\0\1\166\31\0\1\167\26\0\1\170\27\0"+
    "\1\171\24\0\1\130\53\0\1\172\6\0\1\173\1\0"+
    "\1\174\4\0\1\175\30\0\1\176\36\0\1\177\31\0"+
    "\1\142\25\0\10\173\1\175\23\173\24\0\1\200\10\0"+
    "\2\175\1\201\3\0\1\202\44\0\1\203\25\0\1\204"+
    "\45\0\1\205\32\0\1\206\34\0\1\207\37\0\1\210"+
    "\15\0\1\211\50\0\1\212\35\0\1\213\30\0\1\214"+
    "\35\0\1\215\24\0\1\216\27\0\1\217\24\0\1\173"+
    "\53\0\1\220\12\0\1\221\56\0\1\222\11\0\1\175"+
    "\45\0\1\223\44\0\1\224\26\0\1\225\20\0\1\226"+
    "\53\0\1\227\35\0\1\230\15\0\1\231\36\0\1\232"+
    "\43\0\1\233\30\0\1\234\37\0\1\235\26\0\1\236"+
    "\20\0\1\237\37\0\1\240\51\0\1\241\10\0\1\242"+
    "\43\0\1\243\40\0\1\244\32\0\1\245\24\0\1\246"+
    "\26\0\1\247\23\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[4396];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\6\0\1\11\1\1\1\11\5\1\35\0\1\11\55\0"+
    "\1\1\12\0\1\11\1\0\2\11\5\0\1\11\20\0"+
    "\1\11\42\0\1\11\4\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[167];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	ReadDocument() { }
	
	private StringBuilder text = new StringBuilder();
	


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public ReadDocument(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { output.append(yytext());
            }
          // fall through
          case 12: break;
          case 2:
            { text.append(yytext());
            }
          // fall through
          case 13: break;
          case 3:
            { output.append(yytext());

		text = new StringBuilder();
		
		yybegin(inAnnex);
            }
          // fall through
          case 14: break;
          case 4:
            { if(getMarkerDocument().isDebug()) System.out.println("ANNEX START " + yytext());

	output.append(yytext());

	if(getMarkerDocument().getInputType().equals(InputType.PLAIN_GAZZETTA_UFFICIALE) ) {

		getMarkerDocument().getContext().resetAll();
		getMarkerDocument().getContext().updateAnnexContainer(yytext());
		
		text = new StringBuilder();
		
		yybegin(inAnnex);
		
	} else {
	
		yybegin(inAnnexEU);
	}
            }
          // fall through
          case 15: break;
          case 5:
            { //System.out.println("MAIN START " + yytext());
	
	output.append(yytext());
	
	text = new StringBuilder();
	
	yybegin(inMain);
            }
          // fall through
          case 16: break;
          case 6:
            { //Analisi allegato
		/* if(getMarkerDocument().isArticolato() && getMarkerDocument().isAnnexEnabled()) { */
		
		/* Analizza eventuali allegati anche se il documento principale non è articolato. L'analisi degli allegati può essere in ogni caso disabilitata dalla conf di lancio. */ 
		
		if(getMarkerDocument().isAnnexEnabled()) {
			
			String runBodyOutput = Marker.runBody(getMarkerDocument(), text.toString());  
			
			if( !runBodyOutput.equals("")) {
			
				output.append(runBodyOutput);
				
			} else {
			
				//l'allegato non è articolato
			
				output.append(text.toString());
			}

		} else {
		
			//non analizzare eventuali allegati
		
			output.append(text.toString());
		}

		text = new StringBuilder();
		
		output.append(yytext());
		
		yybegin(0);
            }
          // fall through
          case 17: break;
          case 7:
            { output.append(yytext());
		yybegin(0);
            }
          // fall through
          case 18: break;
          case 8:
            { //analisi main
		
		//System.out.println("MAIN END " + yytext());
		
		String runBodyOutput = Marker.runBody(getMarkerDocument(), text.toString());
		
		if( !runBodyOutput.equals("")) {
		
			getMarkerDocument().setArticolato(true);

			output.append(runBodyOutput);
		
		} else {
		
			//il documento main non è articolato
			
			output.append(text.toString());
		}

		text = new StringBuilder();
		
		output.append(yytext());
		
		if(getMarkerDocument().isDebug()) System.out.println("FINE MAIN");

		getMarkerDocument().getContext().setInAnnex(true);
		
		yybegin(0);
            }
          // fall through
          case 19: break;
          case 9:
            { if(getMarkerDocument().isDebug()) System.out.println("ANNEX from HEADER START " + yytext());
		
		output.append(yytext());

		text = new StringBuilder();
		
		yybegin(inAnnex);
            }
          // fall through
          case 20: break;
          case 10:
            { if(getMarkerDocument().isDebug()) System.out.println("ANNEX PHEADER START " + yytext());
	
	getMarkerDocument().getContext().resetAll();
	getMarkerDocument().getContext().updateAnnexContainer(yytext());
		
	output.append(yytext());
	yybegin(inAnnexHeader);
            }
          // fall through
          case 21: break;
          case 11:
            { if(getMarkerDocument().isDebug()) System.out.println("ANNEX MRK_P PHEADER START " + yytext());
	
	getMarkerDocument().getContext().resetAll();
	getMarkerDocument().getContext().updateAnnexContainer(yytext());
		
	output.append(yytext());
	yybegin(inAnnexHeaderWithP);
            }
          // fall through
          case 22: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java ReadDocument [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        ReadDocument scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new ReadDocument(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
